
#include <SPI.h>        //SPI library for communicate with the nRF24L01+
#include "RF24.h"       //The main library of the nRF24L01+
#include "Wire.h"       //For communication
#include "I2Cdev.h"     //For communicate with MPU6050
#include "MPU6050.h"    //The main library of the MPU6050
#include <FastLED.h>
#include <RF24Network.h>
#define LED_PIN     10
#define NUM_LEDS    6

CRGB leds[NUM_LEDS];


//Define the object to access and cotrol the Gyro and Accelerometer (We don't use the Gyro data)
MPU6050 mpu;
int16_t ax, ay, az;
int16_t gx, gy, gz;

//Define packet for the direction (X axis and Y axis)
int data[2];



boolean t1,t2,t3,t4,t5,t6= false;

//Define object from RF24 library - 7 and 8 are a digital pin numbers to which signals CE and CSN are connected.
RF24 radio(7,8);    
RF24Network network(radio);    //include the radio in the network

//Create a pipe addresses for  communication                                    
const uint64_t base00 = 00;  // Address of this node in octal format
const  uint64_t node01 =01;
const  uint64_t node02 =02;
const  uint64_t node03 =03;
const  uint64_t node04 =04;
const  uint64_t node05 =05;
const  uint64_t node06 =0;
 


void setup(){
  
FastLED.addLeds<WS2812, LED_PIN, GRB>(leds, NUM_LEDS);
Serial.begin(9600);
Wire.begin();
Serial.println(mpu.testConnection() ? "Connected" : "Connection failed");
mpu.initialize();              //Initialize the MPU object
radio.begin();                 //Start the nRF24 communicate     
network.begin(90, base00);  //(channel, node address)
radio.setDataRate(RF24_2MBPS);
}

void loop(){
  
network.update();
  
//With this function, the acceleration and gyro values of the axes are taken. 
mpu.getMotion6(&ax, &ay, &az, &gx, &gy, &gz);

 
data[0] = map(ax,-17000 , 17000, -1000, 1000 ); //Send X axis data 
data[1] = map(ay,-17000 , 17000, -1000, 1000);  //Send Y axis data
 


Serial.print(data[0]); 
Serial.print("\t");
Serial.print(data[1]);
Serial.print("\t");
Serial.println(); 




if(data[0]>500 && data[1] >500){
  t1=!t1;
  delay(1000);
}
if(t1==true) {
  leds[0] = CRGB(255, 255, 0);  // Mind Stone
} else {
leds[0] = CRGB(0, 0, 0);
}
FastLED.show();


if(data[1] >500 && data[0]<-500){
  t2=!t2;
  delay(1000);
}
if(t2==true) {
  leds[1] = CRGB(150,80, 0);  //Soul Stone
} else {
leds[1] = CRGB(0, 0, 0);
}
FastLED.show();


if(data[0] > 900){
  t3=!t3;
  delay(1000);
}
if(t3==true) {
  leds[2] = CRGB(255, 0, 0);  //Reality Stone
} else {
leds[2] = CRGB(0, 0, 0);
}
FastLED.show();


if(data[1] > 900){
  t4=!t4;
  delay(1000);
}
if(t4==true) {
  leds[3] = CRGB(0, 0, 250);  //Space Stone
} else {
leds[3] = CRGB(0, 0, 0);
}
FastLED.show();


if(data[1]<-500 && data[0]<-500){
  t5=!t5;
  delay(1000);
}
if(t5==true) {
  leds[4] = CRGB(200, 0, 200);  //Power Stone
} else {
leds[4] = CRGB(0, 0, 0);
}
FastLED.show();


if(data[1] < -900){
  t6=!t6;
  delay(1000);
}
if(t6==true) {
  leds[5] = CRGB(0, 255, 0);   //Time Stone
} else {
leds[5] = CRGB(0, 0, 0);
}
FastLED.show();


//Lamp Switch Control at Node 01 (Reality Stone)
RF24NetworkHeader header(node01);     // (Address where the data is going)
bool s = network.write(header, &data, sizeof(data));

//Lock Door Control at Node 02 (Space Stone)
RF24NetworkHeader header2(node02);     // (Address where the data is going)
bool s2 = network.write(header2, &data, sizeof(data));

//Clock Control at Node 03 (Time Stone)
RF24NetworkHeader header3(node03);     // (Address where the data is going)
bool s3 = network.write(header3, &data, sizeof(data));

//Pet Feeder  Control at Node 04 (Mind Stone)
RF24NetworkHeader header4(node04);     // (Address where the data is going)
bool s4 = network.write(header4, &data, sizeof(data));

// Air Purifier Control at Node 05 (Soul Stone)
RF24NetworkHeader header5(node05);     // (Address where the data is going)
bool s5 = network.write(header5, &data, sizeof(data));

//AC Portable at Node 06 (Power Stone)
RF24NetworkHeader header6(node06);     // (Address where the data is going)
bool s6 = network.write(header6, &data, sizeof(data));

}


